#
# spec file for package adcli
#
# Copyright (c) 2018 Chris Kowalczyk <ckowalczyk@suse.com>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

Name:           adcli
Version:        0.8.2
Release:        150400.17.8.3
Summary:        Tool for performing actions on an Active Directory domain
License:        LGPL-2.0+
Group:          System/Libraries
URL:            http://cgit.freedesktop.org/realmd/adcli
Source0:        http://www.freedesktop.org/software/realmd/releases/%{name}-%{version}.tar.gz
Source1:        http://www.freedesktop.org/software/realmd/releases/%{name}-%{version}.tar.gz.sig
BuildRequires:  automake
BuildRequires:  libxslt-tools
BuildRequires:  openldap2-devel
BuildRequires:  xmlto
BuildRequires:  pkgconfig(libsasl2)
BuildRequires:  pkgconfig(mit-krb5)
BuildRequires:  pkgconfig(netapi)

BuildRoot:      %{_tmppath}/%{name}-%{version}-build

Patch1:         0001-Remove-upper-case-only-check-when-looking-for-the-Ne.patch
Patch2:         0002-Use-strdup-if-offsets-are-used.patch
Patch3:         0003-correct-spelling-of-adcli_tool_computer_delete-descr.patch
Patch4:         0004-doc-explain-that-all-credential-cache-types-are-supp.patch
Patch5:         0005-library-add-adcli_conn_is_writeable.patch
Patch6:         0006-Handle-kvno-increment-for-RODCs.patch
Patch7:         0007-library-add-_adcli_bin_sid_to_str.patch
Patch8:         0008-library-add-_adcli_call_external_program.patch
Patch9:         0009-library-add-_adcli_ldap_parse_sid.patch
Patch10:        0010-library-add-lookup_domain_sid.patch
Patch11:        0011-library-add-adcli_conn_get_domain_sid.patch
Patch12:        0012-Fix-memory-leak-in-test_check_nt_time_string_lifetim.patch
Patch13:        0013-Add-trusted-for-delegation-option.patch
Patch14:        0014-Only-update-attributes-given-on-the-command-line.patch
Patch15:        0015-update-allow-to-add-service-names.patch
Patch16:        0016-Calculate-enctypes-in-a-separate-function.patch
Patch17:        0017-join-add-all-attributes-while-creating-computer-obje.patch
Patch18:        0018-util-add-_adcli_strv_remove_unsorted.patch
Patch19:        0019-Add-add-service-principal-and-remove-service-princip.patch
Patch20:        0020-Do-not-add-service-principals-twice.patch
Patch21:        0021-Do-not-depend-on-default_realm-in-krb5.conf.patch
Patch22:        0022-adutil-add-_adcli_strv_add_unique.patch
Patch23:        0023-adenroll-use-_adcli_strv_add_unique-for-service-prin.patch
Patch24:        0024-Increment-kvno-after-password-change-with-user-creds.patch
Patch25:        0025-library-use-getaddrinfo-with-AI_CANONNAME-to-find-a-.patch
Patch26:        0026-Use-GSS-SPNEGO-if-available.patch
Patch27:        0027-add-option-use-ldaps.patch
Patch28:        0028-tools-add-option-add-samba-data.patch
Patch29:        0029-tools-store-Samba-data-if-requested.patch
Patch30:        0030-make-Samba-data-tool-configurable.patch
Patch31:        0031-fix-typo-in-flag-value.patch
Patch32:        0032-samba-data-tool-needs-to-take-an-argument.patch
Patch33:        0033-doc-add-missing-samba_data_tool_path.xml-.in-to-EXTR.patch
Patch34:        0034-Implement-adcli-testjoin.patch
Patch35:        0035-handle-encryption-types.patch
Patch36:        0036-Add-dont-expire-password-option.patch
Patch37:        0037-Fix-for-dont-expire-password-option-and-join.patch
Patch38:        0038-Remove-errx-from-tools.patch
Patch39:        0039-Set-umask-before-calling-mkdtemp.patch
Patch40:        0040-adenroll-write-SID-before-secret-to-Samba-s-db.patch
Patch41:        0041-populate-samba-secrets-using-offline-domain-join.patch

%description
Library of routines for joining a machine to Active Directory (without samba)
and managing machine accounts there. Will probably expand to cover other AD
related tasks as well.

%package doc
Summary:        Documentation for adcli
Group:          Documentation/Other
Requires:       %{name} = %{version}

%description doc
Library of routines for joining a machine to Active Directory (without samba)
and managing machine accounts there. Will probably expand to cover other AD
related tasks as well.

This package contains the documentation for adcli.

%prep
%setup -q

%autopatch -p1

%build
%configure --disable-static \
           --disable-silent-rules
make %{?_smp_mflags}

%install
%makeinstall
#Remove zero-length file.
pushd %{buildroot}/%{_datadir}/doc/%{name}
rm adcli-docs.proc
popd

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING NEWS README
%{_sbindir}/%{name}
%{_mandir}/man8/adcli.8%{?ext_man}

%files doc
%defattr(-,root,root)
%doc %{_datadir}/doc/%{name}

%changelog
* Tue Dec 19 2023 scabrero@suse.de
- Populate Samba's secrets database using offline domain join;
  (bsc#1214076); Add
  0041-populate-samba-secrets-using-offline-domain-join.patch
* Wed Aug  9 2023 scabrero@suse.de
- Write SID before secret to Samba's db; (bsc#1214076);
  Add 0040-adenroll-write-SID-before-secret-to-Samba-s-db.patch
* Wed Aug 31 2022 scabrero@suse.de
- Remove errx() calls on error conditions to execute the cleanup
  function and delete the krb5 snippets created in /tmp;
  (bsc#1202647);
  * Add 0038-Remove-errx-from-tools.patch
- Set umask before calling mkdtemp; (bsc#1202647);
  * Add 0039-Set-umask-before-calling-mkdtemp.patch
* Mon Oct 25 2021 scabrero@suse.de
- Add --dont-expire-password option; (jsc#sle-21225);
  * 0036-Add-dont-expire-password-option.patch
  * 0037-Fix-for-dont-expire-password-option-and-join.patch
* Fri Apr  9 2021 scabrero@suse.de
- Respect allowed Kerberos encryption types; (bsc#1184462);
  Add 0035-handle-encryption-types.patch
* Mon Mar  9 2020 scabrero@suse.de
- Update samba secrets database after changing the machine password
  (jsc#sle-11503)
  * 0028-tools-add-option-add-samba-data.patch
  * 0029-tools-store-Samba-data-if-requested.patch
  * 0030-make-Samba-data-tool-configurable.patch
  * 0031-fix-typo-in-flag-value.patch
  * 0032-samba-data-tool-needs-to-take-an-argument.patch
  * 0033-doc-add-missing-samba_data_tool_path.xml-.in-to-EXTR.patch
- Support testjoin command (jsc#sle-11503)
  * 0034-Implement-adcli-testjoin.patch
* Thu Feb 20 2020 scabrero@suse.de
- Use GSS-SPNEGO if available (bsc#1162518)
  * 0026-Use-GSS-SPNEGO-if-available.patch
- Add option to use ldaps (bsc#1162518)
  * 0027-add-option-use-ldaps.patch
* Thu Nov 21 2019 scabrero@suse.de
- The userPrincipalName attribute was not added to the created
  machine (bsc#1157491)
- The host FQDN was not properly detected (bsc#1157491)
- Added patches:
  * 0001-Remove-upper-case-only-check-when-looking-for-the-Ne.patch
  * 0002-Use-strdup-if-offsets-are-used.patch
  * 0003-correct-spelling-of-adcli_tool_computer_delete-descr.patch
  * 0004-doc-explain-that-all-credential-cache-types-are-supp.patch
  * 0005-library-add-adcli_conn_is_writeable.patch
  * 0006-Handle-kvno-increment-for-RODCs.patch
  * 0007-library-add-_adcli_bin_sid_to_str.patch
  * 0008-library-add-_adcli_call_external_program.patch
  * 0009-library-add-_adcli_ldap_parse_sid.patch
  * 0010-library-add-lookup_domain_sid.patch
  * 0011-library-add-adcli_conn_get_domain_sid.patch
  * 0012-Fix-memory-leak-in-test_check_nt_time_string_lifetim.patch
  * 0013-Add-trusted-for-delegation-option.patch
  * 0014-Only-update-attributes-given-on-the-command-line.patch
  * 0015-update-allow-to-add-service-names.patch
  * 0016-Calculate-enctypes-in-a-separate-function.patch
  * 0017-join-add-all-attributes-while-creating-computer-obje.patch
  * 0018-util-add-_adcli_strv_remove_unsorted.patch
  * 0019-Add-add-service-principal-and-remove-service-princip.patch
  * 0020-Do-not-add-service-principals-twice.patch
  * 0021-Do-not-depend-on-default_realm-in-krb5.conf.patch
  * 0022-adutil-add-_adcli_strv_add_unique.patch
  * 0023-adenroll-use-_adcli_strv_add_unique-for-service-prin.patch
  * 0024-Increment-kvno-after-password-change-with-user-creds.patch
  * 0025-library-use-getaddrinfo-with-AI_CANONNAME-to-find-a-.patch
* Fri Sep 21 2018 ckowalczyk@suse.com
- Initial build (fate#326619, bsc#1109849)
